// Creamos una gráfica con los datos al macenados en config
var ctx = document.getElementById('myChart').getContext('2d');
//ctx.canvas.width = 256;
//ctx.canvas.height = 512;
var myChart = new Chart(ctx, config);

//var activePoints = [];
var activePoints = config.data.labels;
var imageNumber = 0;
var playImages;
var reportImg = activePoints[0];
//var myChart;

var SCLlayers = []
config.data.datasets.forEach(function (layer) {
    SCLlayers.push(layer.label.toLowerCase().replace(/\s/g, '_'));
});

// mostrar imagen al dar click en los puntos
document.getElementById("myChart").onclick = function (evt) {
    stop();
    // activePoints = myChart.getElementsAtEvent(evt);
    var activePoint = myChart.getElementAtEvent(evt);

    if(activePoint.length>0){

        var firstPoint = activePoint[0];
        var label = myChart.data.labels[firstPoint._index];
        //console.log(firstPoint._datasetIndex)    //indice de la clase a la que pertenece (vegetación, agua, etc.)

        addImageLayer({
          layerDate: label
        });

        //console.log(myChart.legend.legendItems[firstPoint._datasetIndex].text) //nombre de la capa a la que pertenece (vegetación, agua, etc.)
        //if (!firstPoint) return;
        activePoints.forEach(function (value, index) {
            //if(value==firstPoint){
            if (value == label) {
                imageNumber = index;
            }
        });

        var imagePoint = activePoints[imageNumber];
        updateImage(imagePoint);
        //updateImage(firstPoint);
        //alert("{{ IMAGE_PATH }}"+label+"_TCI_60m.jpg");
        //document.getElementById("satImage").src = "{{ IMAGE_PATH }}"+label+"_TCI_60m.jpg";
    }
};




function play() {
    $("#play").hide();
    $("#stop").show();
    // $(".next").hide();
    // $(".prev").hide();
    // $("#showImage").addClass('col-lg-offset-1');
    playImages = setInterval(function () { next(); }, 4000);
}

 //****************************
function scl_on(imagePoint) {
     console.log("scl on!!")
     label = imagePoint;
     //console.log({{SCL_PATH}})
     document.getElementById("satImage").src = "../../static/reports/tmpImages/repsat_test_dev/{{SCL_PATH}}" + label + "_SCL_60m_clasificationMap.png"
     // $(".next").show();
     // $(".prev").show();
}

function open_big_image(image) {
     console.log("Opening big image")
     console.log("image:")
     console.log(image)
     image_big = image.replace("/thumbnails", "");
     console.log(image_big)
     window.open(image_big)
     // $(".next").show();
     // $(".prev").show();
}
//********************************

function stop() {
    clearInterval(playImages)
    // $("#showImage").removeClass('col-lg-offset-1');
    $("#play").show();
    $("#stop").hide();
    // $(".next").show();
    // $(".prev").show();
}

// cambiar el tipo de gráfica
function next() {
    if (imageNumber == (activePoints.length - 1)) {
        imageNumber = 0;
    } else {
        imageNumber++;
    }
    var imagePoint = activePoints[imageNumber];

    if (!imagePoint) return;
    updateImage(imagePoint);
}

function prev() {
    if (imageNumber == 0) {
        imageNumber = activePoints.length - 1;
    } else {
        imageNumber--;
    }

    var imagePoint = activePoints[imageNumber];

    if (!imagePoint) return;
    updateImage(imagePoint);
}

function updateImage(imagePoint) {
    //label = myChart.data.labels[imagePoint._index];
    //datasets = myChart.data.datasets[imagePoint._datasetIndex].label;
    //document.getElementById("titleMap").innerHTML = label + " - " + datasets;
    label = imagePoint;
    reportImg = imagePoint;
    titleLabel = label.slice(0, 4) + "/" + label.slice(4, 6) + "/" + label.slice(6);
    document.getElementById("titleMap").innerHTML = titleLabel;
    document.getElementById("titleSCL").innerHTML = titleLabel

    document.getElementById("satImage").src = "../../static/reports/tmpImages/repsat_test_dev/" + image_path + label + "_TCI_60m.jpg"

    SCLlayers.forEach(function (layer) {
        if (layer != "no_data") {
            document.getElementById("scl_" + layer).src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_" + layer + ".png"
        }
    })

    //document.getElementById("scl_vegetation").src = "../../static/reports/tmpImages/repsat_test_dev/" + scl_path + label + "_SCL_60m_vegetation.png"
}

function change(newType) {
    var ctx = document.getElementById("myChart").getContext("2d");

    // Remove the old chart and all its event handles
    if (myChart) {
        myChart.destroy();

    }

    // Chart.js modifies the object you pass in. Pass a copy of the object so we can use the original object later

    var temp = jQuery.extend(true, {}, config);
    if (newType == "stackedBar"){
        temp.type = "bar";
        temp.options.scales.xAxes = [{ "stacked": true }];
        temp.options.scales.yAxes = [{ "stacked": true }];
    }else{
        temp.type = newType;
        if (newType == 'radar' || newType == 'pie' || newType == 'polarArea' || newType == 'doughnut') {
            temp.options.scales.xAxes = [{ "display": false, "stacked": false }];
            temp.options.scales.yAxes = [{ "display": false, "stacked": false }];
        }
    }

    myChart = new Chart(ctx, temp);
    showGraph(true)
};

let  img, imgWidth=0, slider=false, clicked=0;
function initComparisons() {
    // $("#showSecondImage").show()
    // setTimeout(function() {
        img = document.getElementsByClassName("img-comp-overlay")[0];
        compareImages(img);
    //});
    // setTimeout(function(){
    //     img = document.getElementsByClassName("img-comp-overlay")[0];
    //     compareImages(img);
    // }, 200);
}

function compareImages(img) {
    var  imgHeight;
    /*get the width and height of the img element*/
    imgWidth = document.getElementById("showImage").offsetWidth;
    imgHeight = img.offsetHeight;
    /*set the width of the img element to 50%:*/
    img.style.width = ((imgWidth / 2)) + 15 + "px";
    /*create slider:*/
    slider = document.createElement("DIV");
    slider.setAttribute("class", "img-comp-slider col-lg-offset-2 col-md-offset-2 col-xs-offset-2");
    /*insert slider*/
    img.parentElement.insertBefore(slider, img);
    /*position the slider in the middle:*/
    slider.style.top = (imgHeight / 2) - (slider.offsetHeight / 2) + "px";
    slider.style.left = ((imgWidth / 2) - (slider.offsetWidth / 2)) + 15 + "px";
    /*execute a function when the mouse button is pressed:*/
    slider.addEventListener("mousedown", slideReady);
    /*and another function when the mouse button is released:*/
    window.addEventListener("mouseup", slideFinish);
    /*or touched (for touch screens:*/
    slider.addEventListener("touchstart", slideReady);
    /*and released (for touch screens:*/
    window.addEventListener("touchstop", slideFinish);
}

function slideReady(e) {
    /*prevent any other actions that may occur when moving over the image:*/
    e.preventDefault();
    /*the slider is now clicked and ready to move:*/
    clicked = 1;
    /*execute a function when the slider is moved:*/
    window.addEventListener("mousemove", slideMove);
    window.addEventListener("touchmove", slideMove);
}

function slideFinish() {
    /*the slider is no longer clicked:*/
    clicked = 0;
}

function slideMove(e) {
    var pos;
    /*if the slider is no longer clicked, exit this function:*/
    if (clicked == 0) return false;
    /*get the cursor's x position:*/
    pos = getCursorPos(e)
    /*prevent the slider from being positioned outside the image:*/
    if (pos < 0) pos = 0;
    if (pos > imgWidth) pos = imgWidth;
    /*execute a function that will resize the overlay image according to the cursor:*/
    slide(pos);
}

function getCursorPos(e) {
    var a, x = 0;
    e = e || window.event;
    /*get the x positions of the image:*/
    a = img.getBoundingClientRect();
    /*calculate the cursor's x coordinate, relative to the image:*/
    x = e.pageX - a.left;
    /*consider any page scrolling:*/
    x = x - window.pageXOffset;
    return x;
}

function slide(x) {
    /*resize the image:*/
    img.style.width = x + "px";
    /*position the slider:*/
    slider.style.left = img.offsetWidth - (slider.offsetWidth / 2) + "px";
}

function deleteComparisons(){
    slider.removeEventListener("mousedown", slideReady);
    slider.removeEventListener("touchstart", slideReady);
    window.removeEventListener("mouseup", slideFinish)   ;
    window.removeEventListener("touchstop", slideFinish);
    window.removeEventListener("mousemove", slideMove);
    window.removeEventListener("touchmove", slideMove);
    $(".img-comp-slider").remove();
    slider= false;
}

//deleteComparisons();
//initComparisons();

function selectImage1(date, element) {
    $("#imageListFirst li").removeClass("active");
    element.classList.add("active");
    let label = date.toString();
    label = label.slice(0, 4) + "/" + label.slice(4, 6) + "/" + label.slice(6);
    document.getElementById("titleImageFirst").innerHTML = label;
    document.getElementById("satImageFirst").src = "../../static/reports/tmpImages/repsat_test_dev/" + image_path + date + "_TCI_60m.jpg"
}

function selectImage2(date,element) {
    $("#imageListSecond li").removeClass("active");
    element.classList.add("active");
    let label = date.toString();
    label = label.slice(0, 4) + "/" + label.slice(4, 6) + "/" + label.slice(6);
    document.getElementById("titleImageSecond").innerHTML = label;
    document.getElementById("satImageSecond").src = "../../static/reports/tmpImages/repsat_test_dev/" + image_path + date + "_TCI_60m.jpg"
}

$('.nav-tabs a').on('shown.bs.tab', function (evt) {
    let tab = $(evt.target).text();
    if(tab == "Comparison"){
        initComparisons()
    }
});

$('.nav-tabs a').on('hide.bs.tab', function (evt) {
    let tab = $(evt.target).text();
    if (tab == "Comparison") {
        deleteComparisons();
    }
    if (tab == "Images") {
        stop();
    }
});
